(*****************************************************************************)
(* InsaneNet functions - RoboZapp - 9/5/92                                   *)
(*****************************************************************************)
{$A+,B+,D-,E+,F+,I+,L+,N-,O+,R-,S+,V-}
unit Nsanenet;

interface

uses
  crt, dos, overlay,
  common, mail0, timejunk, file8, tmpcom,
  mmodem, common1;

procedure makenetcall;
procedure donetstuff;
function fivepers(node:astr):boolean;

implementation

uses mail3, mail9;

function fivepers(node:astr):boolean;
var oksofar:boolean;
    i:byte;
begin
  oksofar:=TRUE;
  for i:=1 to 5 do begin
    if(pos('.',node)=0) then begin
      oksofar:=FALSE;
    end else begin
      node:=copy(node,pos('.',node)+1,length(node)-pos('.',node));
    end;
  end;
  fivepers:=oksofar;
end;

function nodelev(node:astr; level:byte):byte;
var i,y:byte;
begin
  for i:=1 to (level-1) do begin
    node:=copy(node,pos('.',node)+1,length(node)-pos('.',node));
  end;
  if(level<6) then begin
    y:=value(copy(node,1,pos('.',node)-1));
  end else begin
    y:=value(node);
  end;
{  sprompt('DEBUG - Nodelev('+cstr(level)+') : '+cstr(y)); }
  nodelev:=y;
end;

function sigpos(node:astr):byte;
var sigsofar,i:byte;
begin
  sigsofar:=0;
  for i:=1 to 6 do begin
    if(nodelev(node,i)<>0) then begin
      sigsofar:=i;
    end;
  end;
{  sprompt('DEBUG - Sigpos: '+cstr(sigsofar)); }
  sigpos:=sigsofar;
end;

function replace(node:astr; reppos,repwith:byte):astr;
var newnode:astr;
    i:byte;
begin
  newnode:='';
  for i:=1 to (reppos-1) do begin
    newnode:=newnode+copy(node,1,pos('.',node));
    node:=copy(node,pos('.',node)+1,length(node)-pos('.',node));
  end;
  node:=copy(node,pos('.',node)+1,length(node)-pos('.',node));
  if(reppos<6) then begin
    newnode:=newnode+cstr(repwith)+'.';
    for i:=(reppos+1) to 5 do begin
      newnode:=newnode+copy(node,1,pos('.',node));
      node:=copy(node,pos('.',node)+1,length(node)-pos('.',node));
    end;
    newnode:=newnode+node;
  end else begin
    newnode:=newnode+cstr(repwith);
  end;
  replace:=newnode;
end;

function nextup(node:astr):astr;
var new:astr;
begin
  new:=replace(node,sigpos(node),0);
  nextup:=new;
end;

function nextnode(node:astr):astr;  { This deal will calculate the next node a }
var i,pert:byte;                         { Message will need to go to, to reach NODE }
    oksofar:boolean;                { If it is currently on CLASICNODE }
begin
 if(node<>clasicnode) then begin
   if(sigpos(node)<sigpos(clasicnode)) then begin
     nextnode:=nextup(clasicnode);
   end else begin
     oksofar:=TRUE;
     for i:=1 to sigpos(clasicnode) do begin
       if(nodelev(node,i)<>nodelev(clasicnode,i)) then begin
	 oksofar:=FALSE;
       end;
     end;
     if(oksofar) then begin
       pert:=0;
       for i:=sigpos(clasicnode)+1 to 6 do begin
         if(pert=0) then begin
           if(nodelev(node,i)<>0) then pert:=i;
         end;
       end;
       nextnode:=replace(clasicnode,pert,nodelev(node,pert));
     end else begin
       nextnode:=nextup(clasicnode);
     end;
  end;
 end else begin
   nextnode:=clasicnode;
 end;
end;

procedure coolnetprint(s:astr);
var i:integer;
begin
  outcom:=FALSE;
  nl;
  sprompt('^4[ ^5'+s+'^4 ]');
  for i:=lenn(s)+6 to 79 do begin
    sprompt('');
  end;
  nl;
  outcom:=TRUE;
end;

procedure preparepacket(packettype,signifigant,sigpos,oyear,omonth,oday,ohour,ominute,osecond:byte; onode:astr);
var i,i1:integer;
    mixr:msgindexrec;
    mheader:mheaderrec;
    totload,startmail,maillen:longint;
    f,f1:file;
    s:string;
    x:byte;

  function needsend:boolean;
  var calctd:ldatetimerec;
      cvt:packdatetime;
      ptr:packdatetimepp;
      newenough:boolean;
      nsi:integer;
  begin
    ptr:=(@mixr.msgdate);
    cvt:=ptr^;
    pdt2dt(cvt,calctd);
    newenough:=FALSE;
{    print('DEBUG - Check '+cstr(calctd.year)+':'+cstr(calctd.month)+':'+cstr(calctd.day)+
      ':'+cstr(calctd.hour)+':'+cstr(calctd.min)+':'+cstr(calctd.sec)); }
    if((calctd.year-1900)>oyear) then begin
      newenough:=TRUE;
    end else if((calctd.year-1900)=oyear) then begin
      if(calctd.month>omonth) then begin
	newenough:=TRUE;
      end else if(calctd.month=omonth) then begin
	if(calctd.day>oday) then begin
	  newenough:=TRUE;
	end else if(calctd.day=oday) then begin
	  if(calctd.hour>ohour) then begin
	    newenough:=TRUE;
	  end else if(calctd.hour=ohour) then begin
	    if(calctd.min>ominute) then begin
	      newenough:=TRUE;
	    end else if(calctd.min=ominute) then begin
	      if(calctd.sec>osecond) then begin
		newenough:=TRUE;
	      end;
	    end;
	  end;
	end;
      end;
    end;
    if((newenough) and (miexist in mixr.msgindexstat)) then begin

    if(packettype=1) then begin
      if(milocal in mixr.msgindexstat) or (mihigher in mixr.msgindexstat) or (mixr.lowernode<>signifigant)
	or (mixr.lowerpos<>sigpos) then begin
	needsend:=TRUE;
      end else begin
	needsend:=FALSE;
      end;
    end else begin
      if(milocal in mixr.msgindexstat) or (not (mihigher in mixr.msgindexstat)) then begin
	needsend:=TRUE;
      end else begin
	needsend:=FALSE;
      end;
    end;

    end else begin
      needsend:=FALSE;
    end;
  end;

begin
  coolnetprint('Preparing Packet');
  assign(f,systat.temppath+'2\PACKET.NET'); rewrite(f,1);
  for i:=1 to numboards do begin
    loadboard(i);
{    print('DEBUG - Checking '+memboard.name); }
    if(memboard.mbtype<>0) then begin
      initbrd(i);
      findhimsg;
{      print('DEBUG - '+cstr(himsg+1)+' messages total'); }
      assign(f1,systat.msgpath+brdfnopen+'.BRD'); reset(f1,1);
      for i1:=0 to himsg do begin
	ensureloaded(i1); mixr:=mintab^[getmixnum(i1)];
	loadmhead(i1,mheader);
{       print('DEBUG - Checking #'+cstr(i1)); }
	if(needsend) then begin
{         print('DEBUG - Writing #'+cstr(i1)); }
	  blockwrite(f,memboard.mbtype,sizeof(byte));  (* Write pointer to # of board *)
	  blockwrite(f,mheader,sizeof(mheaderrec));
	  totload:=0;
{         print('DEBUG - Seeking to '+cstr(mheader.msgptr)); }
	  seek(f1,mheader.msgptr);
	  while(totload<mheader.msglength) do begin
{           print('DEBUG - So far '+cstr(totload)+'/'+cstr(mheader.msglength)); }
	    blockreadstr2(f1,s);
	    blockwritestr2(f,s);
	    inc(totload,length(s)+2);
	  end;
	end;
      end;
      close(f1);
    end;
  end;

  initbrd(-2);  { Here is the netmail shit }
  findhimsg;
  assign(f1,systat.msgpath+'NETMAIL.BRD'); reset(f1,1);
  for i1:=0 to himsg do begin
    ensureloaded(i1);  mixr:=mintab^[getmixnum(i1)];
    loadmhead(i1,mheader);
{    sprint('DEBUG - Mail should go to '+nextnode(mheader.origindate)+' (this is '+onode+')'); }
    if((onode=nextnode(mheader.origindate)) and (miexist in mixr.msgindexstat)) then begin
{      sprint('DEBUG - And is!'); }
      startmail:=filepos(f);
      x:=255;
      blockwrite(f,x,sizeof(byte));
      blockwrite(f,mheader,sizeof(mheaderrec));
      totload:=0;
      seek(f1,mheader.msgptr);
      while(totload<mheader.msglength) do begin
	blockreadstr2(f1,s);
	blockwritestr2(f,s);
	inc(totload,length(s)+2);
      end;
      maillen:=filepos(f)-startmail;
      mixr.msgindexstat:=mixr.msgindexstat-[miexist];
      savemix(mixr,i1);
    end;
  end;
  close(f1);

  i:=0;
  blockwrite(f,i,sizeof(byte));
  close(f);
end;

procedure handlepacket(signifigant,sigpos:byte);
var f:file;
    sticker,mbp:byte;
    gg,i,goesto:integer;
    totload,ohdr:longint;
    mheader:mheaderrec;
    mixr:msgindexrec;
    cvt:packdatetime;
    ptr:packdatetimepp;
    s:string;
    sfo,done:boolean;
    sr:smalrec;
    u:userrec;
begin
  coolnetprint('Sorting Packet');
  assign(f,systat.temppath+'2\INPACKET.NET');  reset(f,1);
  repeat
    blockread(f,sticker,sizeof(byte));
{    print('DEBUG - Message in INSANEnet Base #'+cstr(sticker)); }
    if(sticker<>0) then begin
      blockread(f,mheader,sizeof(mheaderrec));
      if(sticker<=250) then begin
	mbp:=0;
	for i:=1 to numboards do begin
{          print('DEBUG - Checking '+cstr(i)); }
	  loadboard(i);
	  if(memboard.mbtype=sticker) then mbp:=i;
	end;
      end else begin
	if(mheader.origindate=clasicnode) then begin
	  mbp:=255;  { Netmail for this system }
	end else begin
	  mbp:=254;  { Netmail just passing through }
	end;
      end;

{      print('DEBUG - BBS base #'+cstr(mbp)); }

      goesto:=1;

      if(mbp=255) then begin    { Find the user number it goes to if netmail }
	goesto:=0;
	sfo:=(filerec(sf).mode<>fmclosed);
	if (not sfo) then reset(sf);
	gg:=0;
	done:=FALSE;
	while ((gg<filesize(sf)-1) and (not done)) do begin
	  inc(gg);
	  seek(sf,gg); read(sf,sr);
	  if (sr.name=mheader.toi.as) then begin
	    goesto:=sr.number;
	    done:=TRUE;
	  end;
	end;
      end;

      mheader.toi.usernum:=goesto;
      mheader.fromi.usernum:=1;

      if(mbp<>0) and (goesto<>0) then begin
	loadboard(mbp);
	initbrd(mbp);
	findhimsg;
	seek(brdf,filesize(brdf));
	ohdr:=filesize(brdf);
	mheader.msgptr:=filesize(brdf)+sizeof(mheaderrec);
	blockwrite(brdf,mheader,sizeof(mheaderrec));
	totload:=0;
	while(totload<mheader.msglength) do begin
{          print('DEBUG - '+cstr(totload)+'/'+cstr(mheader.msglength)); }
	  blockreadstr2(f,s);
	  blockwritestr2(brdf,s);
	  inc(totload,length(s)+2);
        end;
	getpackdatetime(@mixr.msgdate);
	getdayofweek(mixr.msgdowk);
	with mixr do begin
	  messagenum:=himsg+1;
          if(mbp=255) then messagenum:=goesto;  { If it's netmail }
	  hdrptr:=ohdr;
	  msgid:=messagenum;
	  isreplytoid:=0;
	  if(signifigant=0) then begin
	    msgindexstat:=[miexist]+[mihigher];
	  end else begin
	    msgindexstat:=[miexist];
          end;
	  isreplyto:=0;
	  dec(isreplyto);
	  numreplys:=0;
	  lowernode:=signifigant;
	  lowerpos:=sigpos;
	end;
	newmix(mixr);
        if(mbp=255) then begin  { If it's netmail }
          reset(uf); seek(uf,goesto); read(uf,u);
          inc(u.waiting);
          seek(uf,goesto);  write(uf,u); close(uf);
        end;

      end else begin
	totload:=0;
	while(totload<mheader.msglength) do begin
{           print('DEBUG - '+cstr(totload)+'/'+cstr(mheader.msglength)); }
	  blockreadstr2(f,s);
	  inc(totload,length(s)+2);
	end;
      end;
    end;
  until(sticker=0);
  close(f);
{  print('DEBUG - Done with sorting'); }
end;

procedure deletepackets;
  var f:file;
begin
  assign(f,systat.temppath+'2\PACKET.NET');
  {$I-} reset(f);
  close(f);
  erase(f); {$I+}
  assign(f,systat.temppath+'2\INPACKET.NET');
  {$I-} reset(f);
  close(f);
  erase(f); {$I+}
end;

procedure slavenetcall;
var s:astr;
    a,b,c:boolean;
    newtime:ldatetimerec;
    ch:char;

begin
  outnet(clasicnode+#13);  (* Tell him who we are *)
  inputnet(s,1);  (* Are we calling the right net node? *)
  if(s=#2) then begin
    inputnet(s,20);   (* We aren't?  Where should we call? *)
    sysoplog('Calling wrong net node - should be calling '+s);
  end else begin
    if(systat.hslinknetcall) then begin
      ch:='1';
      usinghslink:=TRUE;
    end else begin
      ch:='0';
      usinghslink:=FALSE;
    end;
    outnet(cstr(systat.netyear)+';'+cstr(systat.netmonth)+';'+cstr(systat.netday)+
      ';'+cstr(systat.nethour)+';'+cstr(systat.netminute)+';'+cstr(systat.netsecond)+';'+ch+#13);
	(* ^^-Tell him the time & date we need messages from *)
      inputnet(s,1);
      if(s='0') then usinghslink:=FALSE;
      delay(2000);
      com_flush_rx;
      preparepacket(2,0,0,systat.netyear,systat.netmonth,systat.netday,systat.nethour,
	systat.netminute,systat.netsecond,nextup(clasicnode));
{      inputnet(s,1);  (* Tell us when you are done *) }
      outnet(#1#13);  (* We're done with our packet *)
      repeat until (not com_rx_empty) or (hangup);
      send1(systat.temppath+'2\PACKET.NET',a,b);
      if(not usinghslink) then receive1(systat.temppath+'2\INPACKET.NET',FALSE,a,b,c);
      handlepacket(0,0);
      getdatetime(newtime);
      systat.netyear:=newtime.year-1900;
      systat.netmonth:=newtime.month;
      systat.netday:=newtime.day;
      systat.nethour:=newtime.hour;
      systat.netminute:=newtime.min;
      systat.netsecond:=newtime.sec;
      savesystat;
      deletepackets;
  end;
end;

procedure makenetcall;
  var s:astr;
      xitearly:boolean;
      tries:byte;
  procedure makeconnection;
  var try:byte;
      rl:real;
      c:char;
  begin
    clrscr;
    coolnetprint('Preparing comport');
    incom:=TRUE;
    outcom:=TRUE;
    spd:=cstr(modemr.waitbaud);
    try:=0;
    c:='x';
    while(try<4) and (c<>'0') do begin
      com_flush_rx;
      outmodemstring000(modemr.hangup,FALSE);
      rl:=timer;
      while(c<>'0') and (abs(timer-rl)<2) do begin
        c:=ccinkey1;
      end;
      inc(try);
    end;
    com_flush_rx;
    coolnetprint('Making connection - try #'+cstr(tries));
    outnet(#13);
    delay(500);
    outnet(#13);
    delay(500);
    outnet(systat.netcall+#13);
    rl:=timer;
  end;

  procedure followscript;
  var buff:astr;
      script:text;
      rl:real;
    procedure waitfor(whatfor:astr);
    var c:char;
	found,inansi:boolean;
	s:astr;
    begin
{      writeln('DEBUG - Waiting for '+whatfor); }
      found:=FALSE;
      inansi:=FALSE;
      buff:='';
      rl:=timer;
      repeat
	if(keypressed) then begin
	  xitearly:=TRUE;
	end;
	c:=com_rx;
	if(c<>#0) then begin
	  dosansi(c);
	  if(length(buff)>159) then begin
	    buff:=copy(buff,2,159);
	  end;
	  buff:=buff+c;
	  if(pos(whatfor,buff)<>0) then begin
	    found:=TRUE;
	  end;
	  if(pos(#13+cstr(modemr.busy)+#13,buff)<>0) then xitearly:=TRUE;
	  if(pos(#13+cstr(modemr.nocarrier)+#13,buff)<>0) then xitearly:=TRUE;
	  if(pos(#13+cstr(modemr.nodialtone)+#13,buff)<>0) then xitearly:=TRUE;
	  if(pos(#13+'0'+#13,buff)<>0) then xitearly:=TRUE;
	end;
      until (found) or (xitearly) or (abs(timer-rl)>30);
      if(not found) then xitearly:=TRUE;
{      writeln('DEBUG - found.'); }
    end;

  begin
    assign(script,'NETCALL.SCR');
    {$I-} reset(script); {$I+}
    if(ioresult=0) then begin
      coolnetprint('Following netcall script');
      while(not eof(script)) do begin
	readln(script,s);
{        writeln('DEBUG - '+s); }
	if(pos('WAITFOR',s)<>0) then begin
	  if(pos('"',s)<>0) then begin
	    s:=copy(s,pos('"',s)+1,length(s)-pos('"',s));
	    if(pos('"',s)<>0) then begin
	      s:=copy(s,1,pos('"',s)-1);
	      waitfor(s);
	    end;
	  end;
	end else if(pos('PUT',s)<>0) then begin
	  if(pos('"',s)<>0) then begin
	    s:=copy(s,pos('"',s)+1,length(s)-pos('"',s));
	    if(pos('"',s)<>0) then begin
	      s:=copy(s,1,pos('"',s)-1);
	      outnet(s+#13);
	    end;
	  end;
	end;
      end;
    end;
    coolnetprint('Waiting for indentification');
    waitfor('Press [ESCAPE] for');
    outnet(#9);
    outnet(netpassword+#13);
  end;
begin
  tries:=0;
  lastcommandovr:=TRUE;
  if(not tryingnet) then begin
    tryingnet:=TRUE;
    sofarnet:=0;
  end;
  repeat
    inc(tries);
    makeconnection;
    xitearly:=FALSE;
    followscript;
    if (not xitearly) then
      slavenetcall;
    dophonehangup(TRUE);
    incom:=FALSE;
    outcom:=FALSE;
  until((xitearly=FALSE) or (tries>=systat.nettriesperattempt) or (keypressed));
  setnetnow;
  inc(sofarnet);
end;

procedure masternetcall;
var othernode,lastnetcall,glue,ons,s:astr;
    oyear,omonth,oday,ohour,ominute,osecond,signifigant,sigpos:byte;
    a,b,c:boolean;

  function othernodeok:boolean;
  var onodechart:array[1..6] of integer;
      i:integer;
      oksofar:boolean;
  begin
    oksofar:=TRUE;
    ons:=othernode;
    for i:=1 to 5 do begin
      if(pos('.',othernode)=0) then begin
	oksofar:=FALSE;
      end else begin
	onodechart[i]:=value(copy(othernode,1,pos('.',othernode)-1));
	othernode:=copy(othernode,pos('.',othernode)+1,length(othernode)-pos('.',othernode));
      end;
    end;
    onodechart[6]:=value(othernode);
    if(onodechart[6]=0) then begin
      if(onodechart[5]=0) then begin
	if(onodechart[4]=0) then begin
	  if(onodechart[3]=0) then begin
	    if(onodechart[2]=0) then begin
	      if(onodechart[1]=0) then begin
		oksofar:=FALSE;
	      end else begin
		signifigant:=onodechart[1];
		onodechart[1]:=0;
		sigpos:=1;
	      end;
	    end else begin
	      signifigant:=onodechart[2];
	      onodechart[2]:=0;
	      sigpos:=2;
	    end;
	  end else begin
	    signifigant:=onodechart[3];
	    onodechart[3]:=0;
	    sigpos:=3;
	  end;
	end else begin
	  signifigant:=onodechart[4];
	  onodechart[4]:=0;
	  sigpos:=4;
	end;
      end else begin
	signifigant:=onodechart[5];
	onodechart[5]:=0;
	sigpos:=5;
      end;
    end else begin
      signifigant:=onodechart[6];
      onodechart[6]:=0;
      sigpos:=6;
    end;
    glue:='';
    for i:=1 to 5 do begin
      glue:=glue+cstr(onodechart[i])+'.'
    end;
    glue:=glue+cstr(onodechart[6]);
    if(glue<>clasicnode) then oksofar:=FALSE;
    othernode:=ons;
    othernodeok:=oksofar;
  end;

  function parselastcall:boolean;
  var oksofar:boolean;
      i:integer;

      function checknget:byte;
      var b:byte;
      begin
	if(pos(';',lastnetcall)=0) then begin
	  oksofar:=FALSE;
	  checknget:=0;
	end else begin
	  b:=value(copy(lastnetcall,1,pos(';',lastnetcall)-1));
	  lastnetcall:=copy(lastnetcall,pos(';',lastnetcall)+1,length(lastnetcall)-pos(';',lastnetcall));
	  checknget:=b;
	end;
      end;

  begin
    oksofar:=TRUE;
    oyear:=checknget;
    omonth:=checknget;
    oday:=checknget;
    ohour:=checknget;
    ominute:=checknget;
    osecond:=checknget;
    if(systat.hslinknetcall) then begin
      if(lastnetcall='1') then begin
	usinghslink:=TRUE;
      end else begin
	usinghslink:=FALSE;
      end;
    end else begin
      usinghslink:=FALSE;
    end;
    parselastcall:=oksofar;
  end;

begin
  tryingnet:=FALSE;
  inputnet(othernode,20);  (* Identify yourself! *)
  if(not othernodeok) then begin
    outnet(#2#13);  (* Hey!  You're calling the wrong net node! *)
    outnet(glue+#13);  (* Here is where you should call. *)
    sysoplog(othernode+' incorrectly tried to do a net exchange.');
    hangup:=TRUE;
  end else begin
    outnet(#1#13);  (* Ok, you are calling the right net node. *)
    inputnet(lastnetcall,80);  (* Tell me what date & time you need from. *)
    if(systat.hslinknetcall) then begin
      outnet('1'+#13);
    end else begin
      outnet('0'+#13);
    end;
    if(not parselastcall) then begin  (* Did he reply in correct format? *)
      sysoplog('Possible net hacker!  Report to RoboZapp immediatly!');
      hangup:=TRUE;
    end else begin
      sysoplog('Net exchange all messages since '+tch(cstr(ohour))+':'+tch(cstr(ominute))+
	':'+tch(cstr(osecond))+' on '+tch(cstr(omonth))+'/'+tch(cstr(oday))+'/'+tch(cstr(oyear))+' with '+othernode);
      com_flush_rx;
      preparepacket(1,signifigant,sigpos,oyear,omonth,oday,ohour,ominute,osecond,othernode);
      outnet(#1#13);  (* Ok, I'm done preparing my packet *)
{      inputnet(s,1);  (* Tell when you are done *) }
      repeat until (not com_rx_empty) or (hangup);
      if(not usinghslink) then receive1(systat.temppath+'2\INPACKET.NET',FALSE,a,b,c);
      send1(systat.temppath+'2\PACKET.NET',a,b);
      handlepacket(signifigant,sigpos);
      deletepackets;
      hangup:=TRUE;
    end;
  end;
end;

procedure donetstuff;
var i:integer;
    c:char;
    pw:astr;
    done:boolean;
    fdt,sdt:ldatetimerec;
begin
  prompt('INSANEnet node '+clasicnode+#10#13);
  prompt('Press [ESCAPE] for '+regbbs+#10#13);
  done:=FALSE;
  getdatetime(fdt);
  while (done=FALSE) and (not hangup) do begin
    getdatetime(sdt);
    if(fdt.sec>sdt.sec) then sdt.sec:=sdt.sec+60;
    if(fdt.sec+15<=sdt.sec) then done:=TRUE;
    if (ch) then c:=chinkey else c:=inkey;
    c:=upcase(c);
    case ord(c) of
      27:begin
	   done:=TRUE;
	 end;
      9:begin
	  inputnet(pw,80);
	  if(pw=netpassword) then begin
	    masternetcall;
	  end;
	end;
    end;
  end;
end;

end.